/**
 *  @author		SVGANIMA
 *  @date		2022
 *  @copyright	GNU GPLv3
 *	@brief		Sets namespace global variables and instances of the core classes (root, svgoooActual, and uiManager)
 */
var svgNS = "http://www.w3.org/2000/svg";
var xlinkNS = "http://www.w3.org/1999/xlink";
var sodipodiNS = "http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd";
var svgoooNS = "http://www.svganima.com/namespace";

logger.report("Creating user interface.");
new root();
new svgoooActual();
new uiManager().seedSVGOOO();