function infoContext() {
    this.container = document.createElement("div");
    this.seed();
}

infoContext.prototype.seed = function() {
    this.buttons = {};

    this.buttons.groupTool = new uiButton('near_me', 'svgoooActual.setTool(1, true);', 'Group selection (F1)', { 'state': svgoooActual.tool == 1 ? 1 : 0, 'radio': true, 'toggle': true, 'class': 'turn-69 floatLeft material-symbols-rounded' }).shepherd;
    this.buttons.elementTool = new uiButton('edit', 'svgoooActual.setTool(2, true);', 'Element selection (F2)', { 'state': svgoooActual.tool == 2 ? 1 : 0, 'radio': true, 'toggle': true, 'class': 'floatLeft' }).shepherd;
    this.buttons.zoomTool = new uiButton('search', 'svgoooActual.setTool(3, true);', 'Zoom (F3)', { 'state': svgoooActual.tool == 3 ? 1 : 0, 'radio': true, 'toggle': true, 'class': 'flip-h floatLeft' }).shepherd;
    this.buttons.animate = new uiButton('movie_creation', 'popup.macroAnimateMenu(svgoooManager.classes.context.buttons.animate.container);', 'Animate element...', { 'toggle': true, 'class': 'heartbeat' }).shepherd;
    this.buttons.edit = new uiButton('settings', 'overlay.macroEdit(svg.selected);', 'Edit attributes', { 'class': 'floatLeft' }).shepherd;
    this.buttons.children = new uiButton('details', 'popup.macroChildren(svgoooManager.classes.context.buttons.children.container, svg.selected);', 'Child nodes...', { 'toggle': true, 'class': 'floatLeft' }).shepherd;
    this.buttons.layers = new uiButton('layers', 'svgoooManager.classes.windowLayers.toggle();', 'Layers', { 'toggle': true }).shepherd;
    this.buttons.keyframes = new uiButton('hourglass_empty', 'svgoooManager.classes.windowAnimation.toggle();', 'Animation keyframes (Ctrl+Shift+K)', { 'toggle': true }).shepherd;
    this.buttons.log = new uiButton('event_note', 'svgoooManager.named.bottom.toggle();svgoooManager.refresh();svgoooActual.settings.set("bottom", !(svgoooActual.settings.get("bottom")));', 'Event log', { 'toggle': true }).shepherd;
    this.buttons.tree = new uiButton('folder', 'svgoooManager.named.left.toggle();svgoooManager.classes.rulerH.refresh();svgoooManager.classes.rulerV.refresh();svgoooActual.settings.set("tree", !(svgoooActual.settings.get("tree")));', 'Objects (Ctrl+Shift+X)', { 'toggle': true }).shepherd;
    this.toolGroups = [];
    this.toolGroups[0] = document.createElement('div');
    this.toolGroups[1] = document.createElement('div');
    this.toolGroups[2] = document.createElement('div');
    this.toolGroups[3] = document.createElement('div');
    this.toolGroups[4] = document.createElement('div');

    this.toolButtons = {};
    this.toolButtons.element = {};
    this.toolButtons.element.toPath = new uiButton('gesture', 'svg.toPath(svg.selected);', 'Convert selected element to paths', { 'class': 'floatLeft' }).shepherd;

    this.toolGroups[2].appendChild(new uiBreak('floatLeft'));
    this.toolGroups[2].appendChild(this.toolButtons.element.toPath.container);

    this.toolButtons.group = {};

    this.toolButtons.group.rotateLeft = new uiButton('rotate_right', 'svg.rotate(svg.selected, { "angle": 90 }, false, true);', 'Rotate 90° clockwise', { 'class': 'floatLeft' }).shepherd;
    this.toolButtons.group.rotateRight = new uiButton('rotate_left', 'svg.rotate(svg.selected, { "angle": -90 }, false, true);', 'Rotate 90° counterclockwise', { 'class': 'floatLeft' }).shepherd;
    this.toolButtons.group.flipH = new uiButton('flip', 'svg.scale(svg.selected, { "scaleX": -1, "scaleY": 1}, false, true);', 'Flip horizontally', { 'class': 'floatLeft' }).shepherd;
    this.toolButtons.group.flipV = new uiButton('flip', 'svg.scale(svg.selected, { "scaleX": 1, "scaleY": -1}, false, true);', 'Flip vertically', { 'class': 'floatLeft turn-90' }).shepherd;

    this.toolButtons.group.moveBot = new uiButton('vertical_align_bottom', 'svg.selected.moveBottom(true);window.dispatchEvent(new Event("treeSeed"));svg.select();', 'Lower element to the bottom (end)', { 'class': 'floatLeft' }).shepherd;
    this.toolButtons.group.moveDown = new uiButton('arrow_downward', 'svg.selected.moveDown(true);window.dispatchEvent(new Event("treeSeed"));svg.select();', 'Lower element one step (page down)', { 'class': 'floatLeft' }).shepherd;
    this.toolButtons.group.moveUp = new uiButton('arrow_upward', 'svg.selected.moveUp(true);window.dispatchEvent(new Event("treeSeed"));svg.select();', 'Raise element one step (page up)', { 'class': 'floatLeft' }).shepherd;
    this.toolButtons.group.moveTop = new uiButton('vertical_align_top', 'svg.selected.moveTop(true);window.dispatchEvent(new Event("treeSeed"));svg.select();', 'Raise element to the top (home)', { 'class': 'floatLeft' }).shepherd;
    this.toolGroups[1].appendChild(this.toolButtons.group.rotateLeft.container);
    this.toolGroups[1].appendChild(this.toolButtons.group.rotateRight.container);
    this.toolGroups[1].appendChild(this.toolButtons.group.flipH.container);
    this.toolGroups[1].appendChild(this.toolButtons.group.flipV.container);
    this.toolGroups[1].appendChild(this.toolButtons.group.moveBot.container);
    this.toolGroups[1].appendChild(this.toolButtons.group.moveDown.container);
    this.toolGroups[1].appendChild(this.toolButtons.group.moveUp.container);
    this.toolGroups[1].appendChild(this.toolButtons.group.moveTop.container);



    this.toolButtons.zoom = {};

    this.toolButtons.zoom.zoomPlus = new uiButton('add', 'svg.zoomAround(null, null, true);', 'Zoom in', { 'class': 'floatLeft' }).shepherd;
    this.toolButtons.zoom.zoomMinus = new uiButton('remove', 'svg.zoomAround(null, null, false);', 'Zoom out', { 'class': 'floatLeft' }).shepherd;
    this.toolButtons.zoom.zoomReset = new uiButton('search', 'svg.zoom = 1; svg.refreshUI(true);', 'Reset zoom', { 'class': 'floatLeft' }).shepherd;
    this.toolGroups[3].appendChild(this.toolButtons.zoom.zoomPlus.container);
    this.toolGroups[3].appendChild(this.toolButtons.zoom.zoomMinus.container);
    this.toolGroups[3].appendChild(new uiBreak('floatLeft'));

    this.buttons.layers.container.addClass('floatRight');
    this.buttons.keyframes.container.addClass('floatRight');
    this.buttons.log.container.addClass('floatRight');
    this.buttons.tree.container.addClass('floatRight');
    this.buttons.groupTool.setRadioChain(this.buttons.elementTool);
    this.buttons.elementTool.setRadioChain(this.buttons.zoomTool);
    this.buttons.zoomTool.setRadioChain(this.buttons.groupTool);

    this.container.appendChild(this.buttons.groupTool.container);
    this.container.appendChild(this.buttons.elementTool.container);
    this.container.appendChild(this.buttons.zoomTool.container);

    this.container.appendChild(new uiBreak('floatLeft'));
    this.container.appendChild(this.buttons.animate.container);
    this.container.appendChild(this.buttons.edit.container);
    this.container.appendChild(new uiBreak('floatLeft'));

    for (var i = 0; i < this.toolGroups.length; i++) {
        this.toolGroups[i].addClass('floatLeft');
        this.toolGroups[i].style.display = 'none';
        this.container.appendChild(this.toolGroups[i]);
    }

    this.container.appendChild(this.buttons.tree.container);
    this.container.appendChild(this.buttons.log.container);
    this.container.appendChild(this.buttons.layers.container);
    this.container.appendChild(this.buttons.keyframes.container);


    this.refresh();
}

infoContext.prototype.refreshButtons = function() {
    var target = svg.selected;

    for (var i = 0; i < this.toolGroups.length; i++) {
        if (i == svgoooActual.tool) {
            this.toolGroups[i].style.display = null;
        } else {
            this.toolGroups[i].style.display = 'none';
        }
    }

    if (svgoooActual.tool == 2) {
        this.toolGroups[1].style.display = null;
    }

    if (!target) { return; }

    if (target.isAnimation() || (target.shepherd && target.shepherd.isAnimation())) {
        this.buttons.keyframes.enable();
        if (this.buttons.animate.state == 1) {
            svgoooManager.classes.windowAnimation.show();
        }
    } else {
        this.buttons.keyframes.disable();
        svgoooManager.classes.windowAnimation.hide();
    }




    if (!target.parentNode) { return; }

    switch (svgoooActual.tool) {
        case 0: // anchor tool (not selectable)
            break;
        case 2: // element selection
            if (typeof svg.selected.toPath !== 'function' || svg.selected instanceof SVGSVGElement || svg.selected instanceof SVGDefsElement) {
                this.toolButtons.element.toPath.disable();
            } else {
                this.toolButtons.element.toPath.enable();
            }
        case 1: // group selection
            if (svg.selected instanceof SVGSVGElement) {
                for (var i in this.toolButtons.group) {
                    this.toolButtons.group[i].disable();
                }
            } else {
                for (var i in this.toolButtons.group) {
                    this.toolButtons.group[i].enable();
                }

                if (!svg.selected.isVisualElement()) {
                    this.toolButtons.group.rotateLeft.disable();
                    this.toolButtons.group.rotateRight.disable();
                    this.toolButtons.group.flipH.disable();
                    this.toolButtons.group.flipV.disable();
                }

                var viable = typeof target.parentNode.getViableChildren === 'function' ? target.parentNode.getViableChildren() : [];
                var i = viable.indexOf(target);
                if (i == 0) {
                    this.toolButtons.group.moveBot.disable();
                    this.toolButtons.group.moveDown.disable();
                }
                if (i == viable.length - 1) {
                    this.toolButtons.group.moveUp.disable();
                    this.toolButtons.group.moveTop.disable();
                }
            }
            break;
        case 3: // zoom tool
            if (svg.zoom == 1) {
                this.toolButtons.zoom.zoomReset.disable();
            } else {
                this.toolButtons.zoom.zoomReset.enable();
            }
            break;
        case 4: // picker
            break;
    }


}

infoContext.prototype.refresh = function() {
    var childNodes = null;

    if (svg.selected != null) {
        if (svg.selected instanceof SVGAnimationElement) {
            this.buttons.keyframes.enable();
            if (this.buttons.keyframes.state == 1) {
                svgoooManager.classes.windowAnimation.show();
            }
        } else if (svg.selected.shepherd && (svg.selected.shepherd instanceof animationGroup || svg.selected.shepherd instanceof animatedViewbox)) {
            this.buttons.keyframes.enable();
            if (this.buttons.keyframes.state == 1) {
                svgoooManager.classes.windowAnimation.show();
            }
        } else {
            this.buttons.keyframes.disable();
        }
        this.refreshButtons();

        childNodes = [];

        for (var i = 0; i < svg.selected.children.length; i++) {
            if (svg.selected.children[i].getAttribute("svganima:lock") == 'interface') { continue; }
            if (svg.selected.children[i].getAttribute("svganima:lock") == 'skip') {
                for (var j = 0; j < svg.selected.children[i].children.length; j++) {
                    childNodes.push({
                        type: 'text',
                        text: "<span class='nodeName'>&lt;" + svg.selected.children[i].children[j].nodeName + "&gt;</span> " + svg.selected.children[i].children[j].id,
                        id: svg.selected.children[i].children[j].id
                    });
                }
                continue;
            }
            svg.selected.children[i].generateId();
            childNodes.push({
                type: 'text',
                text: "<span class='nodeName'>&lt;" + svg.selected.children[i].nodeName + "&gt;</span> " + svg.selected.children[i].id,
                id: svg.selected.children[i].id
            });
        }

        this.buttons.animate.enable();
        this.buttons.edit.enable();
    } else {
        this.buttons.animate.disable();
        this.buttons.edit.disable();
    }
}